/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the ExceptionActionResult type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ExceptionActionResult{}

// ExceptionActionResult An Microsoft.AspNetCore.Mvc.ActionResult with exception information in the body.
type ExceptionActionResult struct {
	// The identifier of the request.
	HttpRequestId NullableString `json:"httpRequestId,omitempty"`
	// A user readable message.
	Message NullableString `json:"message,omitempty"`
}

// NewExceptionActionResult instantiates a new ExceptionActionResult object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewExceptionActionResult() *ExceptionActionResult {
	this := ExceptionActionResult{}
	return &this
}

// NewExceptionActionResultWithDefaults instantiates a new ExceptionActionResult object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewExceptionActionResultWithDefaults() *ExceptionActionResult {
	this := ExceptionActionResult{}
	return &this
}

// GetHttpRequestId returns the HttpRequestId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ExceptionActionResult) GetHttpRequestId() string {
	if o == nil || IsNil(o.HttpRequestId.Get()) {
		var ret string
		return ret
	}
	return *o.HttpRequestId.Get()
}

// GetHttpRequestIdOk returns a tuple with the HttpRequestId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ExceptionActionResult) GetHttpRequestIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.HttpRequestId.Get(), o.HttpRequestId.IsSet()
}

// HasHttpRequestId returns a boolean if a field has been set.
func (o *ExceptionActionResult) HasHttpRequestId() bool {
	if o != nil && o.HttpRequestId.IsSet() {
		return true
	}

	return false
}

// SetHttpRequestId gets a reference to the given NullableString and assigns it to the HttpRequestId field.
func (o *ExceptionActionResult) SetHttpRequestId(v string) {
	o.HttpRequestId.Set(&v)
}

// SetHttpRequestIdNil sets the value for HttpRequestId to be an explicit nil
func (o *ExceptionActionResult) SetHttpRequestIdNil() {
	o.HttpRequestId.Set(nil)
}

// UnsetHttpRequestId ensures that no value is present for HttpRequestId, not even an explicit nil
func (o *ExceptionActionResult) UnsetHttpRequestId() {
	o.HttpRequestId.Unset()
}

// GetMessage returns the Message field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ExceptionActionResult) GetMessage() string {
	if o == nil || IsNil(o.Message.Get()) {
		var ret string
		return ret
	}
	return *o.Message.Get()
}

// GetMessageOk returns a tuple with the Message field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ExceptionActionResult) GetMessageOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Message.Get(), o.Message.IsSet()
}

// HasMessage returns a boolean if a field has been set.
func (o *ExceptionActionResult) HasMessage() bool {
	if o != nil && o.Message.IsSet() {
		return true
	}

	return false
}

// SetMessage gets a reference to the given NullableString and assigns it to the Message field.
func (o *ExceptionActionResult) SetMessage(v string) {
	o.Message.Set(&v)
}

// SetMessageNil sets the value for Message to be an explicit nil
func (o *ExceptionActionResult) SetMessageNil() {
	o.Message.Set(nil)
}

// UnsetMessage ensures that no value is present for Message, not even an explicit nil
func (o *ExceptionActionResult) UnsetMessage() {
	o.Message.Unset()
}

func (o ExceptionActionResult) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ExceptionActionResult) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.HttpRequestId.IsSet() {
		toSerialize["httpRequestId"] = o.HttpRequestId.Get()
	}
	if o.Message.IsSet() {
		toSerialize["message"] = o.Message.Get()
	}
	return toSerialize, nil
}

type NullableExceptionActionResult struct {
	value *ExceptionActionResult
	isSet bool
}

func (v NullableExceptionActionResult) Get() *ExceptionActionResult {
	return v.value
}

func (v *NullableExceptionActionResult) Set(val *ExceptionActionResult) {
	v.value = val
	v.isSet = true
}

func (v NullableExceptionActionResult) IsSet() bool {
	return v.isSet
}

func (v *NullableExceptionActionResult) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableExceptionActionResult(val *ExceptionActionResult) *NullableExceptionActionResult {
	return &NullableExceptionActionResult{value: val, isSet: true}
}

func (v NullableExceptionActionResult) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableExceptionActionResult) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
